<template>
  <div>
    <Spin fix v-show="loadingtype">
      <Icon type="ios-loading" size="18" class="demo-spin-icon-load"></Icon>
      <div>{{ $t('loading') }}</div>
    </Spin>
    <Row>
      <h1 class="tc mb-10">
        <Icon type="ios-chatboxes" />{{ $t('news.title') }}
      </h1>
      <i-Col span="10">
        <Card class="m-5 gray" dis-hover>
          <h2 slot="title">{{ $t('news.carousel') }}</h2>
          <Card class="mb-10" dis-hover>
            <h4 class="mb-10">{{ $t('news.addcarousel') }} ：</h4>
            <Input prefix="ios-image" :placeholder=" $t('news.typing')" v-model="sendimgurl" style="width:88%" />
            <Button type="primary" @click="confirm('1',0)">{{ $t('news.addbtn') }}</Button>
          </Card>
          <Card dis-hover style="height: 30rem;overflow: auto;">
            <table width="100%">
              <thead>
                <tr>
                  <th colspan="10">{{ $t('news.thtitle') }}</th>
                </tr>
                <tr>
                  <th width="30%">{{ $t('news.img') }}</th>
                  <th width="30%">{{ $t('news.updatetime') }}</th>
                  <th width="10%">{{ $t('news.dealman') }}</th>
                  <th width="10%">{{ $t('news.acction') }}</th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="(it,index) in getcarousel" :key="index+'img'" class="tc">
                  <td>
                    <img :src="it.imgurl" width="100%" />
                  </td>
                  <td>{{it.time}}</td>
                  <td>
                    <b>{{it.dealman}}</b>
                  </td>
                  <td>
                    <Button type="warning" @click="confirm('2',it.keypayback)">
                      <Icon type="md-trash" />{{ $t('news.del') }}
                    </Button>
                  </td>
                </tr>
              </tbody>
            </table>
          </Card>
        </Card>
      </i-Col>
      <i-Col span="14">
        <i-Col span="12">
          <Card class="m-5 gray" dis-hover style="height: 42.5rem;overflow: auto;">
            <h2 slot="title">{{ $t('news.postarea') }}</h2>
            <Button type="error" class="fr" @click="confirm('3',[{title:title,content:content}])">{{ $t('news.post') }}</Button>
            <h3>{{ $t('news.texttitle') }}</h3>
            <Input v-model="title" :placeholder="$t('news.typingtitle')" style="width:100%;" class="mt-15 mb-15" />
            <h3>{{ $t('news.context') }}</h3>
            <editor @sendout="getcontent" class="mt-15 mb-15" />
          </Card>
        </i-Col>
        <i-Col span="12">
          <Card class="m-5 gray" dis-hover>
            <h2 slot="title">{{ $t('news.Messagelist') }}</h2>
            <Card dis-hover style="height: 37rem;overflow: auto;">
              <div
                v-for="(it2,index) in textnews"
                :key="index+'it'"
                class="pt-5 pb-15"
                style="border-bottom: 1px solid #bfbfbf;"
              >
                <h4 class="mb-5">{{ $t('news.texttitle') }} ：{{it2.title}}</h4>
                <Button
                  class="fr ml-10"
                  size="small"
                  type="warning"
                  @click="confirm('4',it2.keypayback)"
                >
                  <Icon type="md-trash" />{{ $t('news.delbtn') }}
                </Button>
                <Button class="fr" size="small" type="primary" @click="moreread(it2)">{{ $t('news.readmore') }}</Button>
                <h5>{{it2.time}}</h5>
              </div>
            </Card>
          </Card>
        </i-Col>
      </i-Col>
    </Row>
    <Modal v-model="mod" width="800">
      <h2 slot="header">
        <Icon type="ios-list-box" />
        <span>{{moddata.title}}</span>
      </h2>
      <div slot="footer">
        <Button type="primary" @click="mod=!mod">{{ $t('index.close') }}</Button>
      </div>
      <div>
        {{ $t('news.postime') }}：
        <div class="m-10">
          {{moddata.time}} : {{moddata.time}}
          <br />
          {{ $t('news.postman') }}: {{moddata.dealman}}
        </div>{{ $t('news.postnews') }} ：
        <div class="m-10" v-html="moddata.msg"></div>
      </div>
    </Modal>
  </div>
</template>

<script>
import editor from "~/components/tools/editor.vue";
import moment from "moment";
import firebase from "firebase/app";;
export default {
  middleware:'routerAuth',
  components: {
    editor
  },
  data() {
    return {
      loadingtype: false,
      title:"",
      acount: [],
      getcarousel: [],
      sendimgurl: "",
      textnews: [],
      mod: false,
      moddata: []
    };
  },
  async asyncData() {
    var result = [];
    var result2 = [];
    const db = firebase.firestore();
    const ref = db.collection("carousel");
    await ref.get().then(querySnapshot => {
      querySnapshot.forEach(doc2 => {
        const resultdata = doc2.data();
        resultdata.keypayback = doc2.id;
        result.push(resultdata);
      });
    });
    var sortresult = []
    const ref2 = db.collection("news");
    await ref2.get().then(querySnapshot => {
      querySnapshot.forEach(doc2 => {
        const resultdata = doc2.data();
        resultdata.keypayback = doc2.id;
        result2.push(resultdata);
        sortresult = result2.sort()
      });
    });
    return { getcarousel: result, textnews: result2 };
  },
  mounted() {
    this.acount = JSON.parse(localStorage.getItem("logindata"));
  },
  methods: {
    getcontent(somedata) {
      this.content = somedata;
    },
    moreread(data) {
      this.moddata = data;
      this.mod = !this.mod;
    },

    confirm(set, key) {
      this.$Modal.confirm({
        title: this.$t('news.fun_confirm'),
        content: "<p>"+this.$t('news.fun_confirmtitle')+"</p>",
        onOk: () => {
          if (set == "1") this.sendimg();
          if (set == "2") this.del(key);
          if (set == "3") this.sendnews(key);
          if (set == "4") this.delmsg(key);
        },
        onCancel: () => {
          this.$Message.info(this.$t('news.fun_confirmcancel'));
        }
      });
    },

    getmsg() {
      var result2 = [];
      const db = firebase.firestore();
      const ref2 = db.collection("news");
      ref2.get().then(querySnapshot => {
        querySnapshot.forEach(doc2 => {
          const resultdata = doc2.data();
          resultdata.keypayback = doc2.id;
          result2.push(resultdata);
        });
        return (this.textnews = result2);
      });
    },
    sendnews(data) {
      const sendtitle = data[0].title;
      const sendmsghtml = data[0].content;
      this.loadingtype = !this.loadingtype;
      const setdata = {
        title: sendtitle,
        msg: sendmsghtml,
        dealman: this.acount.user.displayName,
        time: moment(Date.now()).format("LLLL")
      };
      const db = firebase.firestore();
      const ref = db.collection("news");

      if (sendtitle == "" || sendmsghtml == "") {
        this.$Message.warning(this.$t('news.fun_sendnews'));
        this.loadingtype = !this.loadingtype;
      } else {
        ref
          .add(setdata)
          .then(querySnapshot => {
            this.getmsg();
            this.$Message.success(this.$t('news.fun_sendnews_yes'));
            this.loadingtype = !this.loadingtype;
          })
          .catch(err => {
            this.getmsg();
            this.$Message.error(this.$t('news.fun_sendnews_err'), err);
            this.loadingtype = !this.loadingtype;
          });
      }
    },
    delmsg(key) {
      this.loadingtype = !this.loadingtype;
      const db = firebase.firestore();
      const ref = db.collection("news").doc(key);
      ref
        .delete()
        .then(res => {
          this.$Message.success(this.$t('news.fun_delmsg_yes'));
          this.getmsg();
          this.loadingtype = !this.loadingtype;
        })
        .catch(err => {
          this.$Message.error(this.$t('news.fun_delmsg_err'));
          this.getmsg();
          this.loadingtype = !this.loadingtype;
        });
    },

    getimg() {
      var result = [];
      const db = firebase.firestore();
      const ref = db.collection("carousel");
      ref.get().then(querySnapshot => {
        querySnapshot.forEach(doc2 => {
          const resultdata = doc2.data();
          resultdata.keypayback = doc2.id;
          result.push(resultdata);
        });
      });
      return (this.getcarousel = result);
    },
    sendimg() {
      this.loadingtype = !this.loadingtype;
      const db = firebase.firestore();
      const ref = db.collection("carousel");
      if (this.sendimgurl == "") {
        this.$Message.warning(this.$t('news.fun_sendimg_msg'));
        this.loadingtype = !this.loadingtype;
      } else {
        const setdata = {
          imgurl: this.sendimgurl,
          dealman: this.acount.user.displayName,
          time: moment(Date.now()).format("LLLL")
        };
        ref
          .add(setdata)
          .then(data => {
            this.$Message.success(this.$t('news.fun_sendimg_yes'));
            this.loadingtype = !this.loadingtype;
            this.getimg();
            this.sendimgurl = "";
          })
          .catch(err => {
            this.$Message.error(this.$t('news.fun_sendimg_err'), err);
            this.loadingtype = !this.loadingtype;
            this.getimg();
          });
      }
    },
    del(key) {
      this.loadingtype = !this.loadingtype;
      const db = firebase.firestore();
      const ref = db.collection("carousel").doc(key);
      ref
        .delete()
        .then(res => {
          this.$Message.success(this.$t('news.fun_delmsg_yes'));
          this.getimg();
          this.loadingtype = !this.loadingtype;
        })
        .catch(err => {
          this.$Message.error(this.$t('news.fun_delmsg_err'));
          this.getimg();
          this.loadingtype = !this.loadingtype;
        });
    }
  }
};
</script>

<style lang="scss" scoped>
</style>